
REM * Set terminal output and command echoing on; log output of this script.
REM *
#set termout on
#set echo on
spool %create_db_spool_file%

REM * Start the <sid> instance (ORACLE_SID here must be set to <sid>).
REM *
connect internal
startup nomount pfile=%pfile_dir%/init%Oracle_Sid%_0.ora

REM * Create the <dbname> database.  
REM * SYSTEM tablespace configuration guidelines:
REM *   General-Purpose ORACLE RDBMS		    5Mb
REM *   Additional dictionary for applications	10-50Mb 
REM * Redo Log File configuration guidelines:
REM *   Use 3+ redo log files to relieve ``cannot allocate new log...'' waits.
REM *   Use ~100Kb per redo log file per connection to reduce checkpoints.
REM *
create database "%dbname%"
    maxinstances %maxinstances%
    maxlogfiles  %maxlogfiles%
    character set "%db_char_set%"
    datafile
	'%system_file%'	size   %system_size%
    logfile
	'%log1_file%'	size %log1_size%,
	'%log2_file%'	size %log2_size%,
	'%log3_file%'	size %log3_size%;

disconnect
spool off
